"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var immutable_1 = require("immutable");
var TypeAttributes_1 = require("./TypeAttributes");
var Support_1 = require("./support/Support");
var DescriptionTypeAttributeKind = /** @class */ (function (_super) {
    __extends(DescriptionTypeAttributeKind, _super);
    function DescriptionTypeAttributeKind() {
        return _super.call(this, "description") || this;
    }
    DescriptionTypeAttributeKind.prototype.combine = function (a, b) {
        return a.union(b);
    };
    DescriptionTypeAttributeKind.prototype.makeInferred = function (_) {
        return undefined;
    };
    DescriptionTypeAttributeKind.prototype.stringify = function (descriptions) {
        var result = descriptions.first();
        if (result === undefined)
            return undefined;
        if (result.length > 5 + 3) {
            result = result.substr(0, 5) + "...";
        }
        if (descriptions.size > 1) {
            result = result + ", ...";
        }
        return result;
    };
    return DescriptionTypeAttributeKind;
}(TypeAttributes_1.TypeAttributeKind));
exports.descriptionTypeAttributeKind = new DescriptionTypeAttributeKind();
var PropertyDescriptionsTypeAttributeKind = /** @class */ (function (_super) {
    __extends(PropertyDescriptionsTypeAttributeKind, _super);
    function PropertyDescriptionsTypeAttributeKind() {
        return _super.call(this, "propertyDescriptions") || this;
    }
    PropertyDescriptionsTypeAttributeKind.prototype.combine = function (a, b) {
        return a.mergeWith(Support_1.setUnion, b);
    };
    PropertyDescriptionsTypeAttributeKind.prototype.makeInferred = function (_) {
        return undefined;
    };
    return PropertyDescriptionsTypeAttributeKind;
}(TypeAttributes_1.TypeAttributeKind));
exports.propertyDescriptionsTypeAttributeKind = new PropertyDescriptionsTypeAttributeKind();
function descriptionAttributeProducer(schema, _canonicalRef, types) {
    if (!(typeof schema === "object"))
        return undefined;
    var description = TypeAttributes_1.emptyTypeAttributes;
    var propertyDescription = TypeAttributes_1.emptyTypeAttributes;
    var maybeDescription = schema.description;
    if (typeof maybeDescription === "string") {
        description = exports.descriptionTypeAttributeKind.makeAttributes(immutable_1.OrderedSet([maybeDescription]));
    }
    if (types.has("object") && typeof schema.properties === "object") {
        var propertyDescriptions = immutable_1.OrderedMap(schema.properties)
            .map(function (propSchema) {
            if (typeof propSchema === "object") {
                var desc = propSchema.description;
                if (typeof desc === "string") {
                    return immutable_1.OrderedSet([desc]);
                }
            }
            return undefined;
        })
            .filter(function (v) { return v !== undefined; });
        if (!propertyDescriptions.isEmpty()) {
            propertyDescription = exports.propertyDescriptionsTypeAttributeKind.makeAttributes(propertyDescriptions);
        }
    }
    return { forType: TypeAttributes_1.combineTypeAttributes("union", description, propertyDescription) };
}
exports.descriptionAttributeProducer = descriptionAttributeProducer;
