"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var URI = require("urijs");
var immutable_1 = require("immutable");
var JSONSchemaInput_1 = require("./JSONSchemaInput");
var CompressedJSON_1 = require("./CompressedJSON");
var JSONSchemaStore_1 = require("./JSONSchemaStore");
var Support_1 = require("../support/Support");
var Messages_1 = require("../Messages");
var TypeNames_1 = require("../TypeNames");
var Description_1 = require("../Description");
var Inference_1 = require("./Inference");
var All_1 = require("../language/All");
var AccessorNames_1 = require("../AccessorNames");
var InputJSONSchemaStore = /** @class */ (function (_super) {
    __extends(InputJSONSchemaStore, _super);
    function InputJSONSchemaStore(_inputs, _delegate) {
        var _this = _super.call(this) || this;
        _this._inputs = _inputs;
        _this._delegate = _delegate;
        return _this;
    }
    InputJSONSchemaStore.prototype.fetch = function (address) {
        return __awaiter(this, void 0, void 0, function () {
            var maybeInput, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        maybeInput = this._inputs.get(address);
                        if (!(maybeInput !== undefined)) return [3 /*break*/, 2];
                        _a = JSONSchemaInput_1.checkJSONSchema;
                        _b = Support_1.parseJSON;
                        return [4 /*yield*/, Support_1.toString(maybeInput)];
                    case 1: return [2 /*return*/, _a.apply(void 0, [_b.apply(void 0, [_c.sent(), "JSON Schema", address]), function () {
                                return JSONSchemaInput_1.Ref.root(address);
                            }])];
                    case 2:
                        if (this._delegate === undefined) {
                            return [2 /*return*/, Support_1.panic("Schema URI " + address + " requested, but no store given")];
                        }
                        return [4 /*yield*/, this._delegate.fetch(address)];
                    case 3: return [2 /*return*/, _c.sent()];
                }
            });
        });
    };
    return InputJSONSchemaStore;
}(JSONSchemaStore_1.JSONSchemaStore));
var JSONInput = /** @class */ (function () {
    /* tslint:disable:no-unused-variable */
    function JSONInput(_compressedJSON) {
        this._compressedJSON = _compressedJSON;
        this.kind = "json";
        this.needIR = true;
        this.needSchemaProcessing = false;
        this._topLevels = immutable_1.OrderedMap();
    }
    JSONInput.prototype.addSample = function (topLevelName, sample) {
        var topLevel = this._topLevels.get(topLevelName);
        if (topLevel === undefined) {
            topLevel = { samples: [], description: undefined };
            this._topLevels = this._topLevels.set(topLevelName, topLevel);
        }
        topLevel.samples.push(sample);
    };
    JSONInput.prototype.setDescription = function (topLevelName, description) {
        var topLevel = this._topLevels.get(topLevelName);
        if (topLevel === undefined) {
            return Support_1.panic("Trying to set description for a top-level that doesn't exist");
        }
        topLevel.description = description;
    };
    JSONInput.prototype.addSource = function (source) {
        return __awaiter(this, void 0, void 0, function () {
            var name, samples, description, _i, samples_1, sample, value, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        name = source.name, samples = source.samples, description = source.description;
                        _i = 0, samples_1 = samples;
                        _a.label = 1;
                    case 1:
                        if (!(_i < samples_1.length)) return [3 /*break*/, 7];
                        sample = samples_1[_i];
                        value = void 0;
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, this._compressedJSON.readFromStream(Support_1.toReadable(sample))];
                    case 3:
                        value = _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        e_1 = _a.sent();
                        return [2 /*return*/, Messages_1.messageError("MiscJSONParseError", {
                                description: Support_1.withDefault(description, "input"),
                                address: name,
                                message: Support_1.errorMessage(e_1)
                            })];
                    case 5:
                        this.addSample(name, value);
                        if (description !== undefined) {
                            this.setDescription(name, description);
                        }
                        _a.label = 6;
                    case 6:
                        _i++;
                        return [3 /*break*/, 1];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    JSONInput.prototype.finishAddingInputs = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    JSONInput.prototype.singleStringSchemaSource = function () {
        return undefined;
    };
    JSONInput.prototype.addTypes = function (typeBuilder, inferEnums, inferDates, fixedTopLevels) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var inference;
            return __generator(this, function (_a) {
                inference = new Inference_1.TypeInference(typeBuilder, inferEnums, inferDates);
                this._topLevels.forEach(function (_a, name) {
                    var samples = _a.samples, description = _a.description;
                    var tref = inference.inferType(_this._compressedJSON, TypeNames_1.makeNamesTypeAttributes(name, false), samples, fixedTopLevels);
                    typeBuilder.addTopLevel(name, tref);
                    if (description !== undefined) {
                        var attributes = Description_1.descriptionTypeAttributeKind.makeAttributes(immutable_1.OrderedSet([description]));
                        typeBuilder.addAttributes(tref, attributes);
                    }
                });
                return [2 /*return*/];
            });
        });
    };
    return JSONInput;
}());
exports.JSONInput = JSONInput;
function jsonInputForTargetLanguage(targetLanguage, languages) {
    var lang;
    if (typeof targetLanguage === "string") {
        var maybeLang = All_1.languageNamed(targetLanguage, languages);
        if (maybeLang === undefined) {
            return Messages_1.messageError("DriverUnknownOutputLanguage", { lang: targetLanguage });
        }
        lang = maybeLang;
    }
    else {
        lang = targetLanguage;
    }
    var mapping = lang.stringTypeMapping;
    var makeDate = mapping.date !== "string";
    var makeTime = mapping.time !== "string";
    var makeDateTime = mapping.dateTime !== "string";
    var compressedJSON = new CompressedJSON_1.CompressedJSON(makeDate, makeTime, makeDateTime);
    return new JSONInput(compressedJSON);
}
exports.jsonInputForTargetLanguage = jsonInputForTargetLanguage;
var JSONSchemaInput = /** @class */ (function () {
    function JSONSchemaInput(givenSchemaStore, additionalAttributeProducers) {
        if (additionalAttributeProducers === void 0) { additionalAttributeProducers = []; }
        this.kind = "schema";
        this.needSchemaProcessing = true;
        this._schemaStore = undefined;
        this._schemaInputs = immutable_1.Map();
        this._schemaSources = immutable_1.List();
        this._topLevels = immutable_1.OrderedMap();
        this._needIR = false;
        this._schemaStore = givenSchemaStore;
        this._attributeProducers = [Description_1.descriptionAttributeProducer, AccessorNames_1.accessorNamesAttributeProducer];
        this._attributeProducers.concat(additionalAttributeProducers);
    }
    Object.defineProperty(JSONSchemaInput.prototype, "needIR", {
        get: function () {
            return this._needIR;
        },
        enumerable: true,
        configurable: true
    });
    JSONSchemaInput.prototype.addTopLevel = function (name, ref) {
        this._topLevels = this._topLevels.set(name, ref);
    };
    JSONSchemaInput.prototype.addTypes = function (typeBuilder) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, JSONSchemaInput_1.addTypesInSchema(typeBuilder, Support_1.defined(this._schemaStore), this._topLevels, this._attributeProducers)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    JSONSchemaInput.prototype.addSource = function (schemaSource) {
        return __awaiter(this, void 0, void 0, function () {
            var uris, schema, isConverted, normalizedURIs, uriPath, _i, normalizedURIs_1, normalizedURI, _a, normalizedURIs_2, normalizedURI;
            return __generator(this, function (_b) {
                uris = schemaSource.uris, schema = schemaSource.schema, isConverted = schemaSource.isConverted;
                if (isConverted !== true) {
                    this._needIR = true;
                }
                uriPath = "-" + (this._schemaInputs.size + 1);
                if (uris === undefined) {
                    normalizedURIs = [new URI(uriPath)];
                }
                else {
                    normalizedURIs = uris.map(function (uri) {
                        var normalizedURI = new URI(uri).normalize();
                        if (normalizedURI
                            .clone()
                            .hash("")
                            .toString() === "") {
                            normalizedURI.path(uriPath);
                        }
                        return normalizedURI;
                    });
                }
                if (schema === undefined) {
                    Support_1.assert(uris !== undefined, "URIs must be given if schema source is not specified");
                }
                else {
                    for (_i = 0, normalizedURIs_1 = normalizedURIs; _i < normalizedURIs_1.length; _i++) {
                        normalizedURI = normalizedURIs_1[_i];
                        this._schemaInputs = this._schemaInputs.set(normalizedURI
                            .clone()
                            .hash("")
                            .toString(), schema);
                    }
                }
                for (_a = 0, normalizedURIs_2 = normalizedURIs; _a < normalizedURIs_2.length; _a++) {
                    normalizedURI = normalizedURIs_2[_a];
                    this._schemaSources = this._schemaSources.push([normalizedURI, schemaSource]);
                }
                return [2 /*return*/];
            });
        });
    };
    JSONSchemaInput.prototype.finishAddingInputs = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var maybeSchemaStore, schemaStore;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this._schemaSources.isEmpty())
                            return [2 /*return*/];
                        maybeSchemaStore = this._schemaStore;
                        if (this._schemaInputs.isEmpty()) {
                            if (maybeSchemaStore === undefined) {
                                return [2 /*return*/, Support_1.panic("Must have a schema store to process JSON Schema")];
                            }
                        }
                        else {
                            maybeSchemaStore = this._schemaStore = new InputJSONSchemaStore(this._schemaInputs, maybeSchemaStore);
                        }
                        schemaStore = maybeSchemaStore;
                        return [4 /*yield*/, Support_1.forEachSync(this._schemaSources, function (_a) {
                                var normalizedURI = _a[0], source = _a[1];
                                return __awaiter(_this, void 0, void 0, function () {
                                    var _this = this;
                                    var givenName, refs, name;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                givenName = source.name;
                                                return [4 /*yield*/, JSONSchemaInput_1.refsInSchemaForURI(schemaStore, normalizedURI, givenName)];
                                            case 1:
                                                refs = _b.sent();
                                                if (Array.isArray(refs)) {
                                                    name = void 0;
                                                    if (this._schemaSources.size === 1) {
                                                        name = givenName;
                                                    }
                                                    else {
                                                        name = refs[0];
                                                    }
                                                    this.addTopLevel(name, refs[1]);
                                                }
                                                else {
                                                    refs.forEach(function (ref, refName) {
                                                        _this.addTopLevel(refName, ref);
                                                    });
                                                }
                                                return [2 /*return*/];
                                        }
                                    });
                                });
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    JSONSchemaInput.prototype.singleStringSchemaSource = function () {
        if (!this._schemaSources.every(function (_a) {
            var _ = _a[0], schema = _a[1].schema;
            return typeof schema === "string";
        })) {
            return undefined;
        }
        var set = immutable_1.Set(this._schemaSources.map(function (_a) {
            var _ = _a[0], schema = _a[1].schema;
            return schema;
        }));
        if (set.size === 1) {
            return Support_1.defined(set.first());
        }
        return undefined;
    };
    return JSONSchemaInput;
}());
exports.JSONSchemaInput = JSONSchemaInput;
var InputData = /** @class */ (function () {
    function InputData() {
        // We're comparing for identity in this OrderedSet, i.e.,
        // we do each input exactly once.
        // FIXME: Make into an OrderedMap, indexed by kind.
        this._inputs = immutable_1.OrderedSet();
    }
    InputData.prototype.addInput = function (input) {
        this._inputs = this._inputs.add(input);
    };
    InputData.prototype.addSource = function (kind, source, makeInput) {
        return __awaiter(this, void 0, void 0, function () {
            var input;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        input = this._inputs.find(function (i) { return i.kind === kind; });
                        if (input === undefined) {
                            input = makeInput();
                            this.addInput(input);
                        }
                        return [4 /*yield*/, input.addSource(source)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    // FIXME: Any reason we can't do this at the beginning of `addTypes`?
    InputData.prototype.finishAddingInputs = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Support_1.forEachSync(this._inputs, function (input) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, input.finishAddingInputs()];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    InputData.prototype.addTypes = function (typeBuilder, inferEnums, inferDates, fixedTopLevels) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Support_1.forEachSync(this._inputs, function (input) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, input.addTypes(typeBuilder, inferEnums, inferDates, fixedTopLevels)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(InputData.prototype, "needIR", {
        get: function () {
            return this._inputs.some(function (i) { return i.needIR; });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputData.prototype, "needSchemaProcessing", {
        get: function () {
            return this._inputs.some(function (i) { return i.needSchemaProcessing; });
        },
        enumerable: true,
        configurable: true
    });
    InputData.prototype.singleStringSchemaSource = function () {
        var schemaStrings = this._inputs.map(function (i) { return i.singleStringSchemaSource(); }).filter(function (s) { return s !== undefined; });
        if (schemaStrings.size > 1) {
            return Support_1.panic("We have more than one input with a string schema source");
        }
        return schemaStrings.first();
    };
    return InputData;
}());
exports.InputData = InputData;
