import { TargetLanguage } from "../TargetLanguage";
import { Type, ClassType, EnumType } from "../Type";
import { Name, Namer } from "../Naming";
import { ConvenienceRenderer, ForbiddenWordsInfo } from "../ConvenienceRenderer";
import { StringOption, EnumOption, BooleanOption, Option, OptionValues } from "../RendererOptions";
import { RenderContext } from "../Renderer";
export declare type NamingStyle = "pascal" | "camel" | "underscore" | "upper-underscore";
export declare const cPlusPlusOptions: {
    justTypes: BooleanOption;
    namespace: StringOption;
    typeNamingStyle: EnumOption<NamingStyle>;
    memberNamingStyle: EnumOption<NamingStyle>;
    enumeratorNamingStyle: EnumOption<NamingStyle>;
};
export default class CPlusPlusTargetLanguage extends TargetLanguage {
    constructor();
    protected getOptions(): Option<any>[];
    readonly supportsUnionsWithBothNumberTypes: boolean;
    protected makeRenderer(renderContext: RenderContext, untypedOptionValues: {
        [name: string]: any;
    }): CPlusPlusRenderer;
}
export declare class CPlusPlusRenderer extends ConvenienceRenderer {
    private readonly _options;
    private readonly _namespaceNames;
    private readonly _typeNameStyle;
    private readonly _typeNamingFunction;
    private readonly _memberNamingFunction;
    private readonly _caseNamingFunction;
    constructor(targetLanguage: TargetLanguage, renderContext: RenderContext, _options: OptionValues<typeof cPlusPlusOptions>);
    protected forbiddenNamesForGlobalNamespace(): string[];
    protected forbiddenForObjectProperties(_c: ClassType, _className: Name): ForbiddenWordsInfo;
    protected forbiddenForEnumCases(_e: EnumType, _enumName: Name): ForbiddenWordsInfo;
    protected makeNamedTypeNamer(): Namer;
    protected namerForObjectProperty(): Namer;
    protected makeUnionMemberNamer(): null;
    protected makeEnumCaseNamer(): Namer;
    protected readonly needsTypeDeclarationBeforeUse: boolean;
    protected canBeForwardDeclared(t: Type): boolean;
    protected emitDescriptionBlock(lines: string[]): void;
    private emitBlock;
    private emitNamespaces;
    private cppTypeInOptional;
    private variantType;
    private ourQualifier;
    private jsonQualifier;
    private variantIndirection;
    private cppType;
    private emitClass;
    private emitClassFunctions;
    private emitEnum;
    private emitUnionTypedefs;
    private emitUnionFunctions;
    private emitEnumFunctions;
    private emitTopLevelTypedef;
    private emitAllUnionFunctions;
    private emitOptionalHelpers;
    private emitDeclaration(decl);
    private emitTypes;
    protected emitSourceStructure(): void;
}
