import { ConvenienceRenderer } from "../ConvenienceRenderer";
import { EnumOption, Option, StringOption } from "../RendererOptions";
import { TargetLanguage } from "../TargetLanguage";
import { RenderContext } from "../Renderer";
export declare enum Framework {
    None = 0,
    Klaxon = 1,
}
export declare const kotlinOptions: {
    framework: EnumOption<Framework>;
    packageName: StringOption;
};
export default class KotlinTargetLanguage extends TargetLanguage {
    constructor();
    protected getOptions(): Option<any>[];
    readonly supportsOptionalClassProperties: boolean;
    readonly supportsUnionsWithBothNumberTypes: boolean;
    protected makeRenderer(renderContext: RenderContext, untypedOptionValues: {
        [name: string]: any;
    }): ConvenienceRenderer;
}
